local START_TIME = 6 * TICRATE + (3 * TICRATE / 4)


freeslot("MT_DEPRESPB", "sfx_spbmbl")

local function spawnDepressedSPBFrom(spb_mobj)
    local dprSPB= P_SpawnMobj(
        spb_mobj.x, spb_mobj.y, spb_mobj.z,
        MT_DEPRESPB
    )

    dprSPB.target= spb_mobj.target

    S_StartSound(dprSPB, sfx_spbmbl)
end

local function SPBgivesUp(spb_mobj)
    spawnDepressedSPBFrom(spb_mobj)

    S_StopSound(spb_mobj)

    P_RemoveMobj(spb_mobj)
end

local function countActive()
	local pc = 0
	for q in players.iterate
		if not q.spectator then
			pc = $ + 1
		end
	end
	return pc
end


local ACTIVE_PLAYERS=0

addHook("ThinkFrame", function()
	if leveltime==2 then
		ACTIVE_PLAYERS= countActive()
	end
end)

addHook("MobjThinker", function(spb_mobj)
    if (server.SPBAlastCountActive!=nil) and (ACTIVE_PLAYERS==1) then
        -- are you running an SPBAttack round?
        return
    end

    local player= spb_mobj.tracer and spb_mobj.tracer.valid and spb_mobj.tracer.player

    if not player then return end

    if player.exiting then
        SPBgivesUp(spb_mobj)
    end
end, MT_SPB)


function A_DeprSPBexplode(actor, var1, var2)
    local spbexplosion= P_SpawnMobj(actor.x, actor.y, actor.z,
        MT_SPBEXPLOSION
    )
    spbexplosion.target= actor.target
    spbexplosion.extravalue1= 1

    if S_SoundPlaying(actor, sfx_spbmbl) then
        S_StopSoundByID(actor, sfx_spbmbl)
    end

    S_StartSound(actor, sfx_s3k4e)
end



addHook("MobjCollide", function(thing, tmthing)
    if ( thing.z > tmthing.z+tmthing.height ) or
        ( tmthing.z > thing.z+thing.height )
    then
        return
    end

    P_KillMobj(thing)
end, MT_DEPRESPB)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if inflictor and inflictor.player and inflictor.player.kartstuff[k_curshield] then
		P_RemoveMobj(target)
	end
end, MT_DEPRESPB)
